﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections.ObjectModel;
using System.ComponentModel;
using Telerik.Windows.Controls;

namespace SelfReferencingData
{
	class DataItem : ViewModelBase
	{
		public DataItem()
		{
			Children = new ObservableCollection<DataItem>();
			//this.AddCommand = new DelegateCommand((p) => { this.AddItem(); });
		//	this.RemoveCommand = new DelegateCommand((p) => { this.RemoveItem(); });
		}
		public int Id
		{
			get;
			set;
		}
		public int ParentId
		{
			get;
			set;
		}
		public string Text
		{
			get;
			set;
		}
		public DataItemCollection Owner
		{
			get;
			protected set;
		}
		internal void SetOwner(DataItemCollection collection)
		{
			this.Owner = collection;
		}
		internal void SetChildren(ObservableCollection<DataItem> collection)
		{
			this.Children = collection;
		}

		public ObservableCollection<DataItem> Children
		{
			get;
			set;
		}

		public DelegateCommand AddCommand { get; set; }
		//public void AddItem()
		//{
		//    this.Children.Add(new DataItem() { Text = "NewItem", ParentId = this.Id, Id = 001, Owner = this.Owner });
		//}


		public DelegateCommand RemoveCommand { get; set; }
		//public void RemoveItem()
		//{
		//    this.Owner.Remove(this);
		//}
	}
}
